	;
	; The Plasma part.
	;
	; This is actually two plasmas,
	; one for characters and one for colors.
	; The two are independent (look for "test" below).
	;
STANDALONE=0
DEBUG=0

lines		= $C8
cols		= $C9

plasma_pos	= $0800+7*40+14

plasma_draw
	if DEBUG=1
	dec $FF19
	endif
	;
	lda #plasma_pos & 255
	sta plasma_ptr+1
	sta plasma_ptr_2+1
	lda #plasma_pos >> 8
	sta plasma_ptr+2  
	ora #$04
	sta plasma_ptr_2+2
	;
	lda sine1_index+1
	clc
	adc #$01
	cmp #sine1_end-sine1
	bne *+4
	lda #$00
	sta sine1_index+1
	;      
	lda sine2_index+1
	sec
	sbc #$01
	bpl *+4
	lda #(sine2_end-sine2)-1
	sta sine2_index+1
	;
	lda sine3_index+1
	clc
	adc #$01
	cmp #sine3_end-sine3
	bne *+4
	lda #$00
	sta sine3_index+1
	;
plasma_height
	lda #01			; height!!!
	sta lines
	;
pl4	lda lines
	clc
sine1_index
	adc #$00		; sine start value
	tax 
	;
	lda lines
	clc
	adc sine1,x
	sta line_a+1
	;
	tax
	lda sine2,x
	clc
	adc lines
	sta line_a2+1
	;
	ldy #11-1		; width!!!
pl3	
line_a	lda #$00
sine2_index
	adc sine2,y
	tax
	lda final_colors,x
	;lda #$71		; uncomment this to test chars only!
plasma_ptr
	sta $0800,y
	;
line_a2	lda #$00
sine3_index
	adc sine3,y
	ora #$F0		; chars from 0-F are getting fuller, then back to empty, so no lookup is needed
plasma_ptr_2
	sta $0C00,y
	;
	dey
	bpl pl3
	;
	lda plasma_ptr+1	; inc plasma_ptr by 40
	clc
	adc #40
	sta plasma_ptr+1   
	sta plasma_ptr_2+1
	bcc pl5
	;
	inc plasma_ptr+2  
	inc plasma_ptr_2+2
pl5	;
	dec lines
	bne pl4 
	;
	if DEBUG=1
	inc $FF19
	endif
	;
	rts
	;jmp main_plasma_loop
	
plasma_chars	; 256*8 h none
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $00,$FE,$FE,$FE,$FE,$FE,$FE,$FE
	db $00,$7E,$7E,$7E,$7E,$7E,$7E,$00
	db $00,$00,$7C,$7C,$7C,$7C,$7C,$00
	db $00,$00,$3C,$3C,$3C,$3C,$00,$00
	db $00,$00,$00,$38,$38,$38,$00,$00
	db $00,$00,$00,$18,$18,$00,$00,$00
	db $00,$00,$00,$08,$00,$00,$00,$00
	;
	db $00,$00,$00,$08,$00,$00,$00,$00
	db $00,$00,$00,$18,$18,$00,$00,$00
	db $00,$00,$00,$38,$38,$38,$00,$00
	db $00,$00,$3C,$3C,$3C,$3C,$00,$00
	db $00,$00,$7C,$7C,$7C,$7C,$7C,$00
	db $00,$7E,$7E,$7E,$7E,$7E,$7E,$00
	db $00,$FE,$FE,$FE,$FE,$FE,$FE,$FE
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	
	align 256
final_colors
	db $02,$12,$22,$32,$42,$52,$62,$62,$62,$52,$42,$32,$22,$12,$02
	db $07,$17,$27,$37,$47,$57,$67,$67,$67,$57,$47,$37,$27,$17,$07
	db $05,$15,$25,$35,$45,$55,$65,$65,$65,$55,$45,$35,$25,$15,$05
	db $03,$13,$23,$33,$43,$53,$63,$63,$63,$53,$43,$33,$23,$13,$03
	db $06,$16,$26,$36,$46,$56,$66,$66,$66,$56,$46,$36,$26,$16,$06
	db $04,$14,$24,$34,$44,$54,$64,$64,$64,$54,$44,$34,$24,$14,$04
	db $02,$12,$22,$32,$42,$52,$62,$62,$62,$52,$42,$32,$22,$12,$02
	db $07,$17,$27,$37,$47,$57,$67,$67,$67,$57,$47,$37,$27,$17,$07
final_colors_end

	align 256
	; the first two sine tables add up to exactly 256 bytes
sine1
; 96,30
	db $1E,$20,$22,$24,$26,$28,$29,$2B,$2D,$2F,$30,$32,$33,$35,$36,$37
	db $38,$39,$3A,$3A,$3B,$3B,$3C,$3C,$3C,$3C,$3C,$3B,$3B,$3A,$3A,$39
	db $38,$37,$36,$35,$33,$32,$30,$2F,$2D,$2B,$29,$28,$26,$24,$22,$20
	db $1E,$1C,$1A,$18,$16,$14,$13,$11,$0F,$0D,$0C,$0A,$09,$07,$06,$05
	db $04,$03,$02,$02,$01,$01,$00,$00,$00,$00,$00,$01,$01,$02,$02,$03
	db $04,$05,$06,$07,$09,$0A,$0C,$0D,$0F,$11,$13,$14,$16,$18,$1A,$1C
sine1_end
	db $1E,$20,$22,$24,$26,$28,$29,$2B,$2D,$2F,$30,$32,$33,$35,$36,$37
	db $38,$39,$3A,$3A,$3B,$3B,$3C,$3C,$3C,$3C,$3C,$3B,$3B,$3A,$3A,$39
	
	align 256
sine2
; 120,23.5
	db $18,$19,$1A,$1B,$1C,$1E,$1F,$20,$21,$22,$23,$24,$25,$26,$27,$28
	db $29,$2A,$2B,$2B,$2C,$2C,$2D,$2D,$2E,$2E,$2E,$2F,$2F,$2F,$2F,$2F
	db $2F,$2F,$2E,$2E,$2E,$2D,$2D,$2C,$2C,$2B,$2B,$2A,$29,$28,$27,$26
	db $25,$24,$23,$22,$21,$20,$1F,$1E,$1C,$1B,$1A,$19,$18,$16,$15,$14
	db $13,$11,$10,$0F,$0E,$0D,$0C,$0B,$0A,$09,$08,$07,$06,$05,$04,$04
	db $03,$03,$02,$02,$01,$01,$01,$00,$00,$00,$00,$00,$00,$00,$01,$01
	db $01,$02,$02,$03,$03,$04,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D
	db $0E,$0F,$10,$11,$13,$14,$15,$16
sine2_end
	db $18,$19,$1A,$1B,$1C,$1E,$1F,$20,$21,$22,$23,$24,$25,$26,$27,$28
	db $29,$2A,$2B,$2B,$2C,$2C,$2D,$2D,$2E,$2E,$2E,$2F,$2F,$2F,$2F,$2F


 	;
 	align 256
sine3
; 160,17
	db $11,$12,$12,$13,$14,$14,$15,$16,$16,$17,$18,$18,$19,$19,$1A,$1A
	db $1B,$1C,$1C,$1D,$1D,$1D,$1E,$1E,$1F,$1F,$1F,$20,$20,$20,$21,$21
	db $21,$21,$22,$22,$22,$22,$22,$22,$22,$22,$22,$22,$22,$22,$22,$21
	db $21,$21,$21,$20,$20,$20,$1F,$1F,$1F,$1E,$1E,$1D,$1D,$1D,$1C,$1C
	db $1B,$1A,$1A,$19,$19,$18,$18,$17,$16,$16,$15,$14,$14,$13,$12,$12
	db $11,$10,$10,$0F,$0E,$0E,$0D,$0C,$0C,$0B,$0A,$0A,$09,$09,$08,$08
	db $07,$06,$06,$05,$05,$05,$04,$04,$03,$03,$03,$02,$02,$02,$01,$01
	db $01,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	db $01,$01,$01,$02,$02,$02,$03,$03,$03,$04,$04,$05,$05,$05,$06,$06
	db $07,$08,$08,$09,$09,$0A,$0A,$0B,$0C,$0C,$0D,$0E,$0E,$0F,$10,$10
sine3_end
	db $11,$12,$12,$13,$14,$14,$15,$16,$16,$17,$18,$18,$19,$19,$1A,$1A
	db $1B,$1C,$1C,$1D,$1D,$1D,$1E,$1E,$1F,$1F,$1F,$20,$20,$20,$21,$21
	
	
	;org $3800+(40+28)*8
	;include "makes_charset.asm"
	
;eof